# -*- coding: UTF-8 -*-
import sys
try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
except:
	sys.exit(1)

import os
import Cgui_festival


#Clase que trata con el fichero temporal y configuracion de festival
class Cfichero_festival:
	
	#Constructor - Inicia el objeto
	def __init__(self):
		#Variables
		self.fichero_tmp = "/tmp/ffestival_tmp.txt"#fichero temporal que almacena el texto a pronunciar
		self.fichero_cnf = ".festivalrc"#fichero de configuracion de Festival para distintas opciones
	
	#TRABAJAMOS CON LOS FICHERO

	#Archivo de configuracion de Festival (~/.festivalrc)
	#def edit_conf(self,voz,velocidad):
	def edit_conf(self,voz):
		#Voz
		texto = "(set! voice_default '" + voz + ")\n"
		#Velocidad
		#texto += "(set! dur_stretch '" + str(velocidad) + ")\n"
		#texto += "(Parameter.set 'Duration_Method Default)\n"
		#texto += "(Parameter.set 'Duration_Stretch " + str(velocidad) + ")"

		#averiguo en que ruta debe escribirse el fichero
		#para ello averiguo que usuario a iniciado el proceso	
		self.fichero_cnf = str(self.get_puser()) + "/" +self.fichero_cnf

		f = open(self.fichero_cnf, "w")
		f.write(texto)
		f.close()
	
	#Escribe en el fichero temporal el texto indicado
	def putfichero(self,texto):
		f = open(self.fichero_tmp, "w")
		f.write(texto)
		f.close()

	#Borra el fichero para solventar problemas de permisos por distintos usuarios
	def delfichero(self):
		comando = 'rm ' + self.fichero_tmp;
		os.system (comando)

	#Ejecuta festival para que lea el fichero
	def readfichero(self):
		comando = 'cat ' + self.fichero_tmp + ' | iconv -f utf-8 -t iso-8859-1 | festival --tts'
		os.system (comando)
		self.delfichero()
		
		
	#Conocer la carpeta del usuario que lanza el proceso (es necesario para saber donde escribir el fichero .festivalrc)
	def get_puser(self):
		#f=os.popen('getent passwd "' + str(os.getuid()) + '" | cut -d":" -f1')
		f=os.popen('echo $HOME')
		for i in f.readlines():
			pusuario = i
		return pusuario.replace ( "\n", "" )#quito los \n de la lista

